--- old/usr/src/cmd/mandoc/mdoc_macro.c	Fri Jul 25 15:00:14 2014
+++ new/usr/src/cmd/mandoc/mdoc_macro.c	Fri Jul 25 15:00:14 2014
@@ -1,7 +1,7 @@
-/*	$Id: mdoc_macro.c,v 1.115 2012/01/05 00:43:51 schwarze Exp $ */
+/*	$Id: mdoc_macro.c,v 1.125 2013/12/24 20:45:27 schwarze Exp $ */
 /*
- * Copyright (c) 2008, 2009, 2010, 2011 Kristaps Dzonsons <kristaps@bsd.lv>
- * Copyright (c) 2010 Ingo Schwarze <schwarze@openbsd.org>
+ * Copyright (c) 2008-2012 Kristaps Dzonsons <kristaps@bsd.lv>
+ * Copyright (c) 2010, 2012, 2013 Ingo Schwarze <schwarze@openbsd.org>
  *
  * Permission to use, copy, modify, and distribute this software for any
  * purpose with or without fee is hereby granted, provided that the above
@@ -51,8 +51,8 @@
 static	int	  	obsolete(MACRO_PROT_ARGS);
 static	int	  	phrase_ta(MACRO_PROT_ARGS);
 
-static	int		dword(struct mdoc *, int, int, 
-				const char *, enum mdelim);
+static	int		dword(struct mdoc *, int, int, const char *,
+				 enum mdelim, int);
 static	int	  	append_delims(struct mdoc *, 
 				int, int *, char *);
 static	enum mdoct	lookup(enum mdoct, const char *);
@@ -70,128 +70,147 @@
 				enum mdoct, int, int);
 
 const	struct mdoc_macro __mdoc_macros[MDOC_MAX] = {
-	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Ap */
+	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Ap */
 	{ in_line_eoln, MDOC_PROLOGUE }, /* Dd */
 	{ in_line_eoln, MDOC_PROLOGUE }, /* Dt */
 	{ in_line_eoln, MDOC_PROLOGUE }, /* Os */
-	{ blk_full, MDOC_PARSED }, /* Sh */
-	{ blk_full, MDOC_PARSED }, /* Ss */ 
-	{ in_line_eoln, 0 }, /* Pp */ 
-	{ blk_part_imp, MDOC_PARSED }, /* D1 */
-	{ blk_part_imp, MDOC_PARSED }, /* Dl */
+	{ blk_full, MDOC_PARSED | MDOC_JOIN }, /* Sh */
+	{ blk_full, MDOC_PARSED | MDOC_JOIN }, /* Ss */
+	{ in_line_eoln, 0 }, /* Pp */
+	{ blk_part_imp, MDOC_PARSED | MDOC_JOIN }, /* D1 */
+	{ blk_part_imp, MDOC_PARSED | MDOC_JOIN }, /* Dl */
 	{ blk_full, MDOC_EXPLICIT }, /* Bd */
-	{ blk_exp_close, MDOC_EXPLICIT }, /* Ed */
+	{ blk_exp_close, MDOC_EXPLICIT | MDOC_JOIN }, /* Ed */
 	{ blk_full, MDOC_EXPLICIT }, /* Bl */
-	{ blk_exp_close, MDOC_EXPLICIT }, /* El */
-	{ blk_full, MDOC_PARSED }, /* It */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ad */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* An */
+	{ blk_exp_close, MDOC_EXPLICIT | MDOC_JOIN }, /* El */
+	{ blk_full, MDOC_PARSED | MDOC_JOIN }, /* It */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ad */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* An */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ar */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Cd */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Cm */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Dv */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Er */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ev */ 
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Dv */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Er */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ev */
 	{ in_line_eoln, 0 }, /* Ex */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Fa */ 
-	{ in_line_eoln, 0 }, /* Fd */ 
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Fa */
+	{ in_line_eoln, 0 }, /* Fd */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Fl */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Fn */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ft */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ic */ 
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Fn */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ft */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ic */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* In */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Li */
-	{ blk_full, 0 }, /* Nd */ 
-	{ ctx_synopsis, MDOC_CALLABLE | MDOC_PARSED }, /* Nm */ 
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Li */
+	{ blk_full, MDOC_JOIN }, /* Nd */
+	{ ctx_synopsis, MDOC_CALLABLE | MDOC_PARSED }, /* Nm */
 	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Op */
 	{ obsolete, 0 }, /* Ot */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Pa */
 	{ in_line_eoln, 0 }, /* Rv */
-	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* St */ 
+	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* St */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Va */
-	{ ctx_synopsis, MDOC_CALLABLE | MDOC_PARSED }, /* Vt */ 
+	{ ctx_synopsis, MDOC_CALLABLE | MDOC_PARSED }, /* Vt */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Xr */
-	{ in_line_eoln, 0 }, /* %A */
-	{ in_line_eoln, 0 }, /* %B */
-	{ in_line_eoln, 0 }, /* %D */
-	{ in_line_eoln, 0 }, /* %I */
-	{ in_line_eoln, 0 }, /* %J */
+	{ in_line_eoln, MDOC_JOIN }, /* %A */
+	{ in_line_eoln, MDOC_JOIN }, /* %B */
+	{ in_line_eoln, MDOC_JOIN }, /* %D */
+	{ in_line_eoln, MDOC_JOIN }, /* %I */
+	{ in_line_eoln, MDOC_JOIN }, /* %J */
 	{ in_line_eoln, 0 }, /* %N */
-	{ in_line_eoln, 0 }, /* %O */
+	{ in_line_eoln, MDOC_JOIN }, /* %O */
 	{ in_line_eoln, 0 }, /* %P */
-	{ in_line_eoln, 0 }, /* %R */
-	{ in_line_eoln, 0 }, /* %T */
+	{ in_line_eoln, MDOC_JOIN }, /* %R */
+	{ in_line_eoln, MDOC_JOIN }, /* %T */
 	{ in_line_eoln, 0 }, /* %V */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Ac */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Ao */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Aq */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Ac */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Ao */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Aq */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* At */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Bc */
-	{ blk_full, MDOC_EXPLICIT }, /* Bf */ 
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Bo */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Bq */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Bc */
+	{ blk_full, MDOC_EXPLICIT }, /* Bf */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Bo */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Bq */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Bsx */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Bx */
 	{ in_line_eoln, 0 }, /* Db */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Dc */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Do */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Dq */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Ec */
-	{ blk_exp_close, MDOC_EXPLICIT }, /* Ef */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Em */ 
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Dc */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Do */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Dq */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Ec */
+	{ blk_exp_close, MDOC_EXPLICIT | MDOC_JOIN }, /* Ef */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Em */
 	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Eo */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Fx */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Ms */
-	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED | MDOC_IGNDELIM }, /* No */
-	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED | MDOC_IGNDELIM }, /* Ns */
+	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_IGNDELIM | MDOC_JOIN }, /* No */
+	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_IGNDELIM | MDOC_JOIN }, /* Ns */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Nx */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Ox */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Pc */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Pc */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED | MDOC_IGNDELIM }, /* Pf */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Po */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Pq */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Qc */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Ql */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Qo */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Qq */
-	{ blk_exp_close, MDOC_EXPLICIT }, /* Re */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Po */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Pq */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Qc */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Ql */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Qo */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Qq */
+	{ blk_exp_close, MDOC_EXPLICIT | MDOC_JOIN }, /* Re */
 	{ blk_full, MDOC_EXPLICIT }, /* Rs */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Sc */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* So */
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Sq */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Sc */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* So */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Sq */
 	{ in_line_eoln, 0 }, /* Sm */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Sx */
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Sy */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Sx */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Sy */
 	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Tn */
-	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Ux */
+	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Ux */
 	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Xc */
 	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Xo */
-	{ blk_full, MDOC_EXPLICIT | MDOC_CALLABLE }, /* Fo */ 
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Fc */ 
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Oo */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Oc */
+	{ blk_full, MDOC_EXPLICIT | MDOC_CALLABLE }, /* Fo */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Fc */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Oo */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Oc */
 	{ blk_full, MDOC_EXPLICIT }, /* Bk */
-	{ blk_exp_close, MDOC_EXPLICIT }, /* Ek */
+	{ blk_exp_close, MDOC_EXPLICIT | MDOC_JOIN }, /* Ek */
 	{ in_line_eoln, 0 }, /* Bt */
 	{ in_line_eoln, 0 }, /* Hf */
 	{ obsolete, 0 }, /* Fr */
 	{ in_line_eoln, 0 }, /* Ud */
 	{ in_line, 0 }, /* Lb */
-	{ in_line_eoln, 0 }, /* Lp */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Lk */ 
-	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Mt */ 
-	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED }, /* Brq */
-	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED | MDOC_EXPLICIT }, /* Bro */
-	{ blk_exp_close, MDOC_EXPLICIT | MDOC_CALLABLE | MDOC_PARSED }, /* Brc */
-	{ in_line_eoln, 0 }, /* %C */
+	{ in_line_eoln, 0 }, /* Lp */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Lk */
+	{ in_line, MDOC_CALLABLE | MDOC_PARSED }, /* Mt */
+	{ blk_part_imp, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Brq */
+	{ blk_part_exp, MDOC_CALLABLE | MDOC_PARSED |
+			MDOC_EXPLICIT | MDOC_JOIN }, /* Bro */
+	{ blk_exp_close, MDOC_CALLABLE | MDOC_PARSED |
+			 MDOC_EXPLICIT | MDOC_JOIN }, /* Brc */
+	{ in_line_eoln, MDOC_JOIN }, /* %C */
 	{ obsolete, 0 }, /* Es */
 	{ obsolete, 0 }, /* En */
 	{ in_line_argn, MDOC_CALLABLE | MDOC_PARSED }, /* Dx */
-	{ in_line_eoln, 0 }, /* %Q */
+	{ in_line_eoln, MDOC_JOIN }, /* %Q */
 	{ in_line_eoln, 0 }, /* br */
 	{ in_line_eoln, 0 }, /* sp */
 	{ in_line_eoln, 0 }, /* %U */
-	{ phrase_ta, MDOC_CALLABLE | MDOC_PARSED }, /* Ta */
+	{ phrase_ta, MDOC_CALLABLE | MDOC_PARSED | MDOC_JOIN }, /* Ta */
 };
 
 const	struct mdoc_macro * const mdoc_macros = __mdoc_macros;
@@ -203,22 +222,23 @@
  * are errors.
  */
 int
-mdoc_macroend(struct mdoc *m)
+mdoc_macroend(struct mdoc *mdoc)
 {
 	struct mdoc_node *n;
 
 	/* Scan for open explicit scopes. */
 
-	n = MDOC_VALID & m->last->flags ?  m->last->parent : m->last;
+	n = MDOC_VALID & mdoc->last->flags ?
+			mdoc->last->parent : mdoc->last;
 
 	for ( ; n; n = n->parent)
 		if (MDOC_BLOCK == n->type &&
 		    MDOC_EXPLICIT & mdoc_macros[n->tok].flags)
-			mdoc_nmsg(m, n, MANDOCERR_SCOPEEXIT);
+			mdoc_nmsg(mdoc, n, MANDOCERR_SCOPEEXIT);
 
 	/* Rewind to the first. */
 
-	return(rew_last(m, m->first));
+	return(rew_last(mdoc, mdoc->first));
 }
 
 
@@ -263,8 +283,8 @@
 	while (mdoc->last != to) {
 		/*
 		 * Save the parent here, because we may delete the
-		 * m->last node in the post-validation phase and reset
-		 * it to m->last->parent, causing a step in the closing
+		 * mdoc->last node in the post-validation phase and reset
+		 * it to mdoc->last->parent, causing a step in the closing
 		 * out to be lost.
 		 */
 		np = mdoc->last->parent;
@@ -460,7 +480,7 @@
  */
 static int
 make_pending(struct mdoc_node *broken, enum mdoct tok,
-		struct mdoc *m, int line, int ppos)
+		struct mdoc *mdoc, int line, int ppos)
 {
 	struct mdoc_node *breaker;
 
@@ -515,7 +535,7 @@
 			taker->pending = broken->pending;
 		}
 		broken->pending = breaker;
-		mandoc_vmsg(MANDOCERR_SCOPENEST, m->parse, line, ppos,
+		mandoc_vmsg(MANDOCERR_SCOPENEST, mdoc->parse, line, ppos,
 				"%s breaks %s", mdoc_macronames[tok],
 				mdoc_macronames[broken->tok]);
 		return(1);
@@ -530,34 +550,39 @@
 
 
 static int
-rew_sub(enum mdoc_type t, struct mdoc *m, 
+rew_sub(enum mdoc_type t, struct mdoc *mdoc, 
 		enum mdoct tok, int line, int ppos)
 {
 	struct mdoc_node *n;
 
-	n = m->last;
+	n = mdoc->last;
 	while (n) {
 		switch (rew_dohalt(tok, t, n)) {
 		case (REWIND_NONE):
 			return(1);
 		case (REWIND_THIS):
+			n->lastline = line -
+			    (MDOC_NEWLINE & mdoc->flags &&
+			     ! (MDOC_EXPLICIT & mdoc_macros[tok].flags));
 			break;
 		case (REWIND_FORCE):
-			mandoc_vmsg(MANDOCERR_SCOPEBROKEN, m->parse, 
+			mandoc_vmsg(MANDOCERR_SCOPEBROKEN, mdoc->parse, 
 					line, ppos, "%s breaks %s", 
 					mdoc_macronames[tok],
 					mdoc_macronames[n->tok]);
 			/* FALLTHROUGH */
 		case (REWIND_MORE):
+			n->lastline = line -
+			    (MDOC_NEWLINE & mdoc->flags ? 1 : 0);
 			n = n->parent;
 			continue;
 		case (REWIND_LATER):
-			if (make_pending(n, tok, m, line, ppos) ||
+			if (make_pending(n, tok, mdoc, line, ppos) ||
 			    MDOC_BLOCK != t)
 				return(1);
 			/* FALLTHROUGH */
 		case (REWIND_ERROR):
-			mdoc_pmsg(m, line, ppos, MANDOCERR_NOSCOPE);
+			mdoc_pmsg(mdoc, line, ppos, MANDOCERR_NOSCOPE);
 			return(1);
 		}
 		break;
@@ -564,7 +589,7 @@
 	}
 
 	assert(n);
-	if ( ! rew_last(m, n))
+	if ( ! rew_last(mdoc, n))
 		return(0);
 
 	/*
@@ -572,10 +597,10 @@
 	 * Now that the current block ends, close the enclosing block, too.
 	 */
 	while (NULL != (n = n->pending)) {
-		if ( ! rew_last(m, n))
+		if ( ! rew_last(mdoc, n))
 			return(0);
 		if (MDOC_HEAD == n->type &&
-		    ! mdoc_body_alloc(m, n->line, n->pos, n->tok))
+		    ! mdoc_body_alloc(mdoc, n->line, n->pos, n->tok))
 			return(0);
 	}
 
@@ -587,18 +612,26 @@
  * Punctuation consists of those tokens found in mdoc_isdelim().
  */
 static int
-dword(struct mdoc *m, int line, 
-		int col, const char *p, enum mdelim d)
+dword(struct mdoc *mdoc, int line, int col, const char *p,
+		enum mdelim d, int may_append)
 {
 	
 	if (DELIM_MAX == d)
 		d = mdoc_isdelim(p);
 
-	if ( ! mdoc_word_alloc(m, line, col, p))
+	if (may_append &&
+	    ! ((MDOC_SYNOPSIS | MDOC_KEEP | MDOC_SMOFF) & mdoc->flags) &&
+	    DELIM_NONE == d && MDOC_TEXT == mdoc->last->type &&
+	    DELIM_NONE == mdoc_isdelim(mdoc->last->string)) {
+		mdoc_word_append(mdoc, p);
+		return(1);
+	}
+
+	if ( ! mdoc_word_alloc(mdoc, line, col, p))
 		return(0);
 
 	if (DELIM_OPEN == d)
-		m->last->flags |= MDOC_DELIMO;
+		mdoc->last->flags |= MDOC_DELIMO;
 
 	/*
 	 * Closing delimiters only suppress the preceding space
@@ -610,15 +643,16 @@
 	 *	and solve this in the code related to `No'!
 	 */
 
-	else if (DELIM_CLOSE == d && m->last->prev &&
-			m->last->prev->tok != MDOC_No)
-		m->last->flags |= MDOC_DELIMC;
+	else if (DELIM_CLOSE == d && mdoc->last->prev &&
+			mdoc->last->prev->tok != MDOC_No &&
+			mdoc->last->parent->tok != MDOC_Fd)
+		mdoc->last->flags |= MDOC_DELIMC;
 
 	return(1);
 }
 
 static int
-append_delims(struct mdoc *m, int line, int *pos, char *buf)
+append_delims(struct mdoc *mdoc, int line, int *pos, char *buf)
 {
 	int		 la;
 	enum margserr	 ac;
@@ -629,7 +663,7 @@
 
 	for (;;) {
 		la = *pos;
-		ac = mdoc_zargs(m, line, pos, buf, &p);
+		ac = mdoc_zargs(mdoc, line, pos, buf, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -636,7 +670,7 @@
 		else if (ARGS_EOLN == ac)
 			break;
 
-		dword(m, line, la, p, DELIM_MAX);
+		dword(mdoc, line, la, p, DELIM_MAX, 1);
 
 		/*
 		 * If we encounter end-of-sentence symbols, then trigger
@@ -650,7 +684,7 @@
 		 * example, `.  ;' shouldn't propagate the double-space.
 		 */
 		if (mandoc_eos(p, strlen(p), 0))
-			m->last->flags |= MDOC_EOS;
+			mdoc->last->flags |= MDOC_EOS;
 	}
 
 	return(1);
@@ -672,12 +706,14 @@
 	enum mdoct	 atok, ntok;
 	char		*p;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	switch (tok) {
 	case (MDOC_Ec):
 		maxargs = 1;
 		break;
+	case (MDOC_Ek):
+		mdoc->flags &= ~MDOC_KEEP;
 	default:
 		maxargs = 0;
 		break;
@@ -689,7 +725,7 @@
 	 */
 	atok = rew_alt(tok);
 	body = later = NULL;
-	for (n = m->last; n; n = n->parent) {
+	for (n = mdoc->last; n; n = n->parent) {
 		if (MDOC_VALID & n->flags)
 			continue;
 
@@ -718,13 +754,13 @@
 			 * postpone closing out the current block
 			 * until the rew_sub() closing out the sub-block.
 			 */
-			make_pending(later, tok, m, line, ppos);
+			make_pending(later, tok, mdoc, line, ppos);
 
 			/*
 			 * Mark the place where the formatting - but not
 			 * the scope - of the current block ends.
 			 */
-			if ( ! mdoc_endbody_alloc(m, line, ppos,
+			if ( ! mdoc_endbody_alloc(mdoc, line, ppos,
 			    atok, body, ENDBODY_SPACE))
 				return(0);
 			break;
@@ -738,7 +774,7 @@
 		if (later &&
 		    MDOC_EXPLICIT & mdoc_macros[later->tok].flags)
 			continue;
-		if (MDOC_CALLABLE & mdoc_macros[n->tok].flags)
+		if (MDOC_It != n->tok)
 			later = n;
 	}
 
@@ -745,18 +781,18 @@
 	if ( ! (MDOC_CALLABLE & mdoc_macros[tok].flags)) {
 		/* FIXME: do this in validate */
 		if (buf[*pos]) 
-			mdoc_pmsg(m, line, ppos, MANDOCERR_ARGSLOST);
+			mdoc_pmsg(mdoc, line, ppos, MANDOCERR_ARGSLOST);
 
-		if ( ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+		if ( ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 			return(0);
-		return(rew_sub(MDOC_BLOCK, m, tok, line, ppos));
+		return(rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos));
 	}
 
-	if ( ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+	if ( ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 		return(0);
 
 	if (NULL == later && maxargs > 0) 
-		if ( ! mdoc_tail_alloc(m, line, ppos, rew_alt(tok)))
+		if ( ! mdoc_tail_alloc(mdoc, line, ppos, rew_alt(tok)))
 			return(0);
 
 	for (flushed = j = 0; ; j++) {
@@ -763,12 +799,12 @@
 		lastarg = *pos;
 
 		if (j == maxargs && ! flushed) {
-			if ( ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+			if ( ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 				return(0);
 			flushed = 1;
 		}
 
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -780,27 +816,31 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, lastarg, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, lastarg, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
 		if ( ! flushed) {
-			if ( ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+			if ( ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 				return(0);
 			flushed = 1;
 		}
-		if ( ! mdoc_macro(m, ntok, line, lastarg, pos, buf))
+
+		mdoc->flags &= ~MDOC_NEWLINE;
+
+		if ( ! mdoc_macro(mdoc, ntok, line, lastarg, pos, buf))
 			return(0);
 		break;
 	}
 
-	if ( ! flushed && ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+	if ( ! flushed && ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 		return(0);
 
 	if ( ! nl)
 		return(1);
-	return(append_delims(m, line, pos, buf));
+	return(append_delims(mdoc, line, pos, buf));
 }
 
 
@@ -815,7 +855,7 @@
 	struct mdoc_arg	*arg;
 	char		*p;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/*
 	 * Whether we allow ignored elements (those without content,
@@ -843,7 +883,7 @@
 
 	for (arg = NULL;; ) {
 		la = *pos;
-		av = mdoc_argv(m, line, tok, &arg, pos, buf);
+		av = mdoc_argv(mdoc, line, tok, &arg, pos, buf);
 
 		if (ARGV_WORD == av) {
 			*pos = la;
@@ -860,7 +900,7 @@
 
 	for (cnt = scope = 0;; ) {
 		la = *pos;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -879,23 +919,25 @@
 		 */
 
 		if (MDOC_MAX != ntok) {
-			if (scope && ! rew_elem(m, tok))
+			if (scope && ! rew_elem(mdoc, tok))
 				return(0);
 			if (nc && 0 == cnt) {
-				if ( ! mdoc_elem_alloc(m, line, ppos, tok, arg))
+				if ( ! mdoc_elem_alloc(mdoc, line,
+						ppos, tok, arg))
 					return(0);
-				if ( ! rew_last(m, m->last))
+				if ( ! rew_last(mdoc, mdoc->last))
 					return(0);
 			} else if ( ! nc && 0 == cnt) {
 				mdoc_argv_free(arg);
-				mdoc_pmsg(m, line, ppos, MANDOCERR_MACROEMPTY);
+				mdoc_pmsg(mdoc, line, ppos,
+					MANDOCERR_MACROEMPTY);
 			}
 
-			if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+			if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 				return(0);
 			if ( ! nl)
 				return(1);
-			return(append_delims(m, line, pos, buf));
+			return(append_delims(mdoc, line, pos, buf));
 		} 
 
 		/* 
@@ -917,7 +959,8 @@
 			 */
 			if (0 == cnt && (nc || MDOC_Li == tok) && 
 					DELIM_CLOSE == d && ! scope) {
-				if ( ! mdoc_elem_alloc(m, line, ppos, tok, arg))
+				if ( ! mdoc_elem_alloc(mdoc, line,
+						ppos, tok, arg))
 					return(0);
 				if (MDOC_Ar == tok || MDOC_Li == tok || 
 						MDOC_Fl == tok)
@@ -928,11 +971,11 @@
 			 * Close out our scope, if one is open, before
 			 * any punctuation.
 			 */
-			if (scope && ! rew_elem(m, tok))
+			if (scope && ! rew_elem(mdoc, tok))
 				return(0);
 			scope = 0;
 		} else if ( ! scope) {
-			if ( ! mdoc_elem_alloc(m, line, ppos, tok, arg))
+			if ( ! mdoc_elem_alloc(mdoc, line, ppos, tok, arg))
 				return(0);
 			scope = 1;
 		}
@@ -940,7 +983,8 @@
 		if (DELIM_NONE == d)
 			cnt++;
 
-		if ( ! dword(m, line, la, p, d))
+		if ( ! dword(mdoc, line, la, p, d,
+		    MDOC_JOIN & mdoc_macros[tok].flags))
 			return(0);
 
 		/*
@@ -949,13 +993,13 @@
 		 * having to parse out spaces.
 		 */
 		if (scope && MDOC_Fl == tok) {
-			if ( ! rew_elem(m, tok))
+			if ( ! rew_elem(mdoc, tok))
 				return(0);
 			scope = 0;
 		}
 	}
 
-	if (scope && ! rew_elem(m, tok))
+	if (scope && ! rew_elem(mdoc, tok))
 		return(0);
 
 	/*
@@ -965,18 +1009,18 @@
 	 */
 
 	if (nc && 0 == cnt) {
-		if ( ! mdoc_elem_alloc(m, line, ppos, tok, arg))
+		if ( ! mdoc_elem_alloc(mdoc, line, ppos, tok, arg))
 			return(0);
-		if ( ! rew_last(m, m->last))
+		if ( ! rew_last(mdoc, mdoc->last))
 			return(0);
 	} else if ( ! nc && 0 == cnt) {
 		mdoc_argv_free(arg);
-		mdoc_pmsg(m, line, ppos, MANDOCERR_MACROEMPTY);
+		mdoc_pmsg(mdoc, line, ppos, MANDOCERR_MACROEMPTY);
 	}
 
 	if ( ! nl)
 		return(1);
-	return(append_delims(m, line, pos, buf));
+	return(append_delims(mdoc, line, pos, buf));
 }
 
 
@@ -994,14 +1038,14 @@
 	enum margverr	  av;
 	char		 *p;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/* Close out prior implicit scope. */
 
 	if ( ! (MDOC_EXPLICIT & mdoc_macros[tok].flags)) {
-		if ( ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+		if ( ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 			return(0);
-		if ( ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+		if ( ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 			return(0);
 	}
 
@@ -1016,7 +1060,7 @@
 
 	for (arg = NULL;; ) {
 		la = *pos;
-		av = mdoc_argv(m, line, tok, &arg, pos, buf);
+		av = mdoc_argv(mdoc, line, tok, &arg, pos, buf);
 
 		if (ARGV_WORD == av) {
 			*pos = la;
@@ -1032,7 +1076,7 @@
 		return(0);
 	}
 
-	if ( ! mdoc_block_alloc(m, line, ppos, tok, arg))
+	if ( ! mdoc_block_alloc(mdoc, line, ppos, tok, arg))
 		return(0);
 
 	head = body = NULL;
@@ -1042,8 +1086,8 @@
 	 * parsed, even though `It' macros in general are parsed.
 	 */
 	nparsed = MDOC_It == tok &&
-		MDOC_Bl == m->last->parent->tok &&
-		LIST_diag == m->last->parent->norm->Bl.type;
+		MDOC_Bl == mdoc->last->parent->tok &&
+		LIST_diag == mdoc->last->parent->norm->Bl.type;
 
 	/*
 	 * The `Nd' macro has all arguments in its body: it's a hybrid
@@ -1051,16 +1095,19 @@
 	 */
 
 	if (MDOC_Nd == tok) {
-		if ( ! mdoc_head_alloc(m, line, ppos, tok))
+		if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 			return(0);
-		head = m->last;
-		if ( ! rew_sub(MDOC_HEAD, m, tok, line, ppos))
+		head = mdoc->last;
+		if ( ! rew_sub(MDOC_HEAD, mdoc, tok, line, ppos))
 			return(0);
-		if ( ! mdoc_body_alloc(m, line, ppos, tok))
+		if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 			return(0);
-		body = m->last;
-	} 
+		body = mdoc->last;
+	}
 
+	if (MDOC_Bk == tok)
+		mdoc->flags |= MDOC_KEEP;
+
 	ac = ARGS_ERROR;
 
 	for ( ; ; ) {
@@ -1067,7 +1114,7 @@
 		la = *pos;
 		/* Initialise last-phrase-type with ARGS_PEND. */
 		lac = ARGS_ERROR == ac ? ARGS_PEND : ac;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_PUNCT == ac)
 			break;
@@ -1085,11 +1132,11 @@
 			 * reopen our scope if the last parse was a
 			 * phrase or partial phrase.
 			 */
-			if ( ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+			if ( ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 				return(0);
-			if ( ! mdoc_body_alloc(m, line, ppos, tok))
+			if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 				return(0);
-			body = m->last;
+			body = mdoc->last;
 			break;
 		}
 
@@ -1104,7 +1151,7 @@
 				ARGS_PPHRASE != ac &&
 				ARGS_QWORD != ac &&
 				DELIM_OPEN == mdoc_isdelim(p)) {
-			if ( ! dword(m, line, la, p, DELIM_OPEN))
+			if ( ! dword(mdoc, line, la, p, DELIM_OPEN, 0))
 				return(0);
 			continue;
 		}
@@ -1112,9 +1159,9 @@
 		/* Open a head if one hasn't been opened. */
 
 		if (NULL == head) {
-			if ( ! mdoc_head_alloc(m, line, ppos, tok))
+			if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 				return(0);
-			head = m->last;
+			head = mdoc->last;
 		}
 
 		if (ARGS_PHRASE == ac || 
@@ -1126,14 +1173,14 @@
 			 */
 
 			mtt = body ? MDOC_BODY : MDOC_HEAD;
-			if ( ! rew_sub(mtt, m, tok, line, ppos))
+			if ( ! rew_sub(mtt, mdoc, tok, line, ppos))
 				return(0);
 			
 			/* Then allocate our body context. */
 
-			if ( ! mdoc_body_alloc(m, line, ppos, tok))
+			if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 				return(0);
-			body = m->last;
+			body = mdoc->last;
 
 			/*
 			 * Process phrases: set whether we're in a
@@ -1142,14 +1189,14 @@
 			 */
 
 			if (ARGS_PPHRASE == ac)
-				m->flags |= MDOC_PPHRASE;
+				mdoc->flags |= MDOC_PPHRASE;
 			if (ARGS_PEND == ac && ARGS_PPHRASE == lac)
-				m->flags |= MDOC_PPHRASE;
+				mdoc->flags |= MDOC_PPHRASE;
 
-			if ( ! phrase(m, line, la, buf))
+			if ( ! phrase(mdoc, line, la, buf))
 				return(0);
 
-			m->flags &= ~MDOC_PPHRASE;
+			mdoc->flags &= ~MDOC_PPHRASE;
 			continue;
 		}
 
@@ -1157,23 +1204,24 @@
 			MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
-		if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+		if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 			return(0);
 		break;
 	}
 
 	if (NULL == head) {
-		if ( ! mdoc_head_alloc(m, line, ppos, tok))
+		if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 			return(0);
-		head = m->last;
+		head = mdoc->last;
 	}
 	
-	if (nl && ! append_delims(m, line, pos, buf))
+	if (nl && ! append_delims(mdoc, line, pos, buf))
 		return(0);
 
 	/* If we've already opened our body, exit now. */
@@ -1187,7 +1235,7 @@
 	 * head to body until the rew_sub() call closing out that
 	 * sub-block.
 	 */
-	for (n = m->last; n && n != head; n = n->parent) {
+	for (n = mdoc->last; n && n != head; n = n->parent) {
 		if (MDOC_BLOCK == n->type && 
 				MDOC_EXPLICIT & mdoc_macros[n->tok].flags &&
 				! (MDOC_VALID & n->flags)) {
@@ -1198,21 +1246,21 @@
 
 	/* Close out scopes to remain in a consistent state. */
 
-	if ( ! rew_sub(MDOC_HEAD, m, tok, line, ppos))
+	if ( ! rew_sub(MDOC_HEAD, mdoc, tok, line, ppos))
 		return(0);
-	if ( ! mdoc_body_alloc(m, line, ppos, tok))
+	if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 		return(0);
 
 out:
-	if ( ! (MDOC_FREECOL & m->flags))
+	if ( ! (MDOC_FREECOL & mdoc->flags))
 		return(1);
 
-	if ( ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+	if ( ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 		return(0);
-	if ( ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+	if ( ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 		return(0);
 
-	m->flags &= ~MDOC_FREECOL;
+	mdoc->flags &= ~MDOC_FREECOL;
 	return(1);
 }
 
@@ -1228,7 +1276,7 @@
 	struct mdoc_node *body; /* saved body context */
 	struct mdoc_node *n;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/*
 	 * A macro that spans to the end of the line.  This is generally
@@ -1239,14 +1287,14 @@
 	 * or more closing punctuation nodes.
 	 */
 
-	if ( ! mdoc_block_alloc(m, line, ppos, tok, NULL))
+	if ( ! mdoc_block_alloc(mdoc, line, ppos, tok, NULL))
 		return(0);
 
-	blk = m->last;
+	blk = mdoc->last;
 
-	if ( ! mdoc_head_alloc(m, line, ppos, tok))
+	if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 		return(0);
-	if ( ! rew_sub(MDOC_HEAD, m, tok, line, ppos))
+	if ( ! rew_sub(MDOC_HEAD, mdoc, tok, line, ppos))
 		return(0);
 
 	/*
@@ -1257,7 +1305,7 @@
 
 	for (body = NULL; ; ) {
 		la = *pos;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1268,26 +1316,27 @@
 
 		if (NULL == body && ARGS_QWORD != ac &&
 				DELIM_OPEN == mdoc_isdelim(p)) {
-			if ( ! dword(m, line, la, p, DELIM_OPEN))
+			if ( ! dword(mdoc, line, la, p, DELIM_OPEN, 0))
 				return(0);
 			continue;
-		} 
+		}
 
 		if (NULL == body) {
-		       if ( ! mdoc_body_alloc(m, line, ppos, tok))
+		       if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 			       return(0);
-			body = m->last;
+			body = mdoc->last;
 		}
 
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
-		if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+		if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 			return(0);
 		break;
 	}
@@ -1295,9 +1344,9 @@
 	/* Clean-ups to leave in a consistent state. */
 
 	if (NULL == body) {
-		if ( ! mdoc_body_alloc(m, line, ppos, tok))
+		if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 			return(0);
-		body = m->last;
+		body = mdoc->last;
 	}
 
 	for (n = body->child; n && n->next; n = n->next)
@@ -1324,12 +1373,13 @@
 	 * postpone closing out the current block
 	 * until the rew_sub() call closing out the sub-block.
 	 */
-	for (n = m->last; n && n != body && n != blk->parent; n = n->parent) {
+	for (n = mdoc->last; n && n != body && n != blk->parent;
+			n = n->parent) {
 		if (MDOC_BLOCK == n->type &&
 		    MDOC_EXPLICIT & mdoc_macros[n->tok].flags &&
 		    ! (MDOC_VALID & n->flags)) {
-			make_pending(n, tok, m, line, ppos);
-			if ( ! mdoc_endbody_alloc(m, line, ppos,
+			make_pending(n, tok, mdoc, line, ppos);
+			if ( ! mdoc_endbody_alloc(mdoc, line, ppos,
 			    tok, body, ENDBODY_NOSPACE))
 				return(0);
 			return(1);
@@ -1343,22 +1393,29 @@
 	 * crufty use of `Op' breakage.
 	 */
 	if (n != body)
-		mandoc_vmsg(MANDOCERR_SCOPENEST, m->parse, line, ppos, 
+		mandoc_vmsg(MANDOCERR_SCOPENEST, mdoc->parse, line, ppos, 
 				"%s broken", mdoc_macronames[tok]);
 
-	if (n && ! rew_sub(MDOC_BODY, m, tok, line, ppos))
+	if (n && ! rew_sub(MDOC_BODY, mdoc, tok, line, ppos))
 		return(0);
 
 	/* Standard appending of delimiters. */
 
-	if (nl && ! append_delims(m, line, pos, buf))
+	if (nl && ! append_delims(mdoc, line, pos, buf))
 		return(0);
 
 	/* Rewind scope, if applicable. */
 
-	if (n && ! rew_sub(MDOC_BLOCK, m, tok, line, ppos))
+	if (n && ! rew_sub(MDOC_BLOCK, mdoc, tok, line, ppos))
 		return(0);
 
+	/* Move trailing .Ns out of scope. */
+
+	for (n = body->child; n && n->next; n = n->next)
+		/* Do nothing. */ ;
+	if (n && MDOC_Ns == n->tok)
+		mdoc_node_relink(mdoc, n);
+
 	return(1);
 }
 
@@ -1373,7 +1430,7 @@
 	char		 *p;
 	enum mdoct	  ntok;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/*
 	 * The opening of an explicit macro having zero or more leading
@@ -1381,12 +1438,12 @@
 	 * case of `Eo'); and a body that may be empty.
 	 */
 
-	if ( ! mdoc_block_alloc(m, line, ppos, tok, NULL))
+	if ( ! mdoc_block_alloc(mdoc, line, ppos, tok, NULL))
 		return(0); 
 
 	for (head = body = NULL; ; ) {
 		la = *pos;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1400,16 +1457,16 @@
 		if (NULL == head && ARGS_QWORD != ac &&
 				DELIM_OPEN == mdoc_isdelim(p)) {
 			assert(NULL == body);
-			if ( ! dword(m, line, la, p, DELIM_OPEN))
+			if ( ! dword(mdoc, line, la, p, DELIM_OPEN, 0))
 				return(0);
 			continue;
-		} 
+		}
 
 		if (NULL == head) {
 			assert(NULL == body);
-			if ( ! mdoc_head_alloc(m, line, ppos, tok))
+			if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 				return(0);
-			head = m->last;
+			head = mdoc->last;
 		}
 
 		/*
@@ -1421,14 +1478,14 @@
 			assert(head);
 			/* No check whether it's a macro! */
 			if (MDOC_Eo == tok)
-				if ( ! dword(m, line, la, p, DELIM_MAX))
+				if ( ! dword(mdoc, line, la, p, DELIM_MAX, 0))
 					return(0);
 
-			if ( ! rew_sub(MDOC_HEAD, m, tok, line, ppos))
+			if ( ! rew_sub(MDOC_HEAD, mdoc, tok, line, ppos))
 				return(0);
-			if ( ! mdoc_body_alloc(m, line, ppos, tok))
+			if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 				return(0);
-			body = m->last;
+			body = mdoc->last;
 
 			if (MDOC_Eo == tok)
 				continue;
@@ -1439,12 +1496,13 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
-		if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+		if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 			return(0);
 		break;
 	}
@@ -1452,13 +1510,13 @@
 	/* Clean-up to leave in a consistent state. */
 
 	if (NULL == head)
-		if ( ! mdoc_head_alloc(m, line, ppos, tok))
+		if ( ! mdoc_head_alloc(mdoc, line, ppos, tok))
 			return(0);
 
 	if (NULL == body) {
-		if ( ! rew_sub(MDOC_HEAD, m, tok, line, ppos))
+		if ( ! rew_sub(MDOC_HEAD, mdoc, tok, line, ppos))
 			return(0);
-		if ( ! mdoc_body_alloc(m, line, ppos, tok))
+		if ( ! mdoc_body_alloc(mdoc, line, ppos, tok))
 			return(0);
 	}
 
@@ -1466,7 +1524,7 @@
 
 	if ( ! nl)
 		return(1);
-	return(append_delims(m, line, pos, buf));
+	return(append_delims(mdoc, line, pos, buf));
 }
 
 
@@ -1481,7 +1539,7 @@
 	char		*p;
 	enum mdoct	 ntok;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/*
 	 * A line macro that has a fixed number of arguments (maxargs).
@@ -1513,7 +1571,7 @@
 
 	for (arg = NULL; ; ) {
 		la = *pos;
-		av = mdoc_argv(m, line, tok, &arg, pos, buf);
+		av = mdoc_argv(mdoc, line, tok, &arg, pos, buf);
 
 		if (ARGV_WORD == av) {
 			*pos = la;
@@ -1531,7 +1589,7 @@
 
 	for (flushed = j = 0; ; ) {
 		la = *pos;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1543,15 +1601,15 @@
 		if ( ! (MDOC_IGNDELIM & mdoc_macros[tok].flags) && 
 				ARGS_QWORD != ac && 0 == j && 
 				DELIM_OPEN == mdoc_isdelim(p)) {
-			if ( ! dword(m, line, la, p, DELIM_OPEN))
+			if ( ! dword(mdoc, line, la, p, DELIM_OPEN, 0))
 				return(0);
 			continue;
 		} else if (0 == j)
-		       if ( ! mdoc_elem_alloc(m, line, la, tok, arg))
+		       if ( ! mdoc_elem_alloc(mdoc, line, la, tok, arg))
 			       return(0);
 
 		if (j == maxargs && ! flushed) {
-			if ( ! rew_elem(m, tok))
+			if ( ! rew_elem(mdoc, tok))
 				return(0);
 			flushed = 1;
 		}
@@ -1559,10 +1617,10 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX != ntok) {
-			if ( ! flushed && ! rew_elem(m, tok))
+			if ( ! flushed && ! rew_elem(mdoc, tok))
 				return(0);
 			flushed = 1;
-			if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+			if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 				return(0);
 			j++;
 			break;
@@ -1572,26 +1630,27 @@
 				ARGS_QWORD != ac &&
 				! flushed &&
 				DELIM_NONE != mdoc_isdelim(p)) {
-			if ( ! rew_elem(m, tok))
+			if ( ! rew_elem(mdoc, tok))
 				return(0);
 			flushed = 1;
 		}
 
-		if ( ! dword(m, line, la, p, DELIM_MAX))
+		if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+		    MDOC_JOIN & mdoc_macros[tok].flags))
 			return(0);
 		j++;
 	}
 
-	if (0 == j && ! mdoc_elem_alloc(m, line, la, tok, arg))
+	if (0 == j && ! mdoc_elem_alloc(mdoc, line, la, tok, arg))
 	       return(0);
 
 	/* Close out in a consistent state. */
 
-	if ( ! flushed && ! rew_elem(m, tok))
+	if ( ! flushed && ! rew_elem(mdoc, tok))
 		return(0);
 	if ( ! nl)
 		return(1);
-	return(append_delims(m, line, pos, buf));
+	return(append_delims(mdoc, line, pos, buf));
 }
 
 
@@ -1608,13 +1667,13 @@
 	assert( ! (MDOC_PARSED & mdoc_macros[tok].flags));
 
 	if (tok == MDOC_Pp)
-		rew_sub(MDOC_BLOCK, m, MDOC_Nm, line, ppos);
+		rew_sub(MDOC_BLOCK, mdoc, MDOC_Nm, line, ppos);
 
 	/* Parse macro arguments. */
 
 	for (arg = NULL; ; ) {
 		la = *pos;
-		av = mdoc_argv(m, line, tok, &arg, pos, buf);
+		av = mdoc_argv(mdoc, line, tok, &arg, pos, buf);
 
 		if (ARGV_WORD == av) {
 			*pos = la;
@@ -1631,7 +1690,7 @@
 
 	/* Open element scope. */
 
-	if ( ! mdoc_elem_alloc(m, line, ppos, tok, arg))
+	if ( ! mdoc_elem_alloc(mdoc, line, ppos, tok, arg))
 		return(0);
 
 	/* Parse argument terms. */
@@ -1638,7 +1697,7 @@
 
 	for (;;) {
 		la = *pos;
-		ac = mdoc_args(m, line, pos, buf, tok, &p);
+		ac = mdoc_args(mdoc, line, pos, buf, tok, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1648,19 +1707,20 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup(tok, p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
-		if ( ! rew_elem(m, tok))
+		if ( ! rew_elem(mdoc, tok))
 			return(0);
-		return(mdoc_macro(m, ntok, line, la, pos, buf));
+		return(mdoc_macro(mdoc, ntok, line, la, pos, buf));
 	}
 
 	/* Close out (no delimiters). */
 
-	return(rew_elem(m, tok));
+	return(rew_elem(mdoc, tok));
 }
 
 
@@ -1670,15 +1730,15 @@
 {
 	int		 nl;
 
-	nl = MDOC_NEWLINE & m->flags;
+	nl = MDOC_NEWLINE & mdoc->flags;
 
 	/* If we're not in the SYNOPSIS, go straight to in-line. */
-	if ( ! (MDOC_SYNOPSIS & m->flags))
-		return(in_line(m, tok, line, ppos, pos, buf));
+	if ( ! (MDOC_SYNOPSIS & mdoc->flags))
+		return(in_line(mdoc, tok, line, ppos, pos, buf));
 
 	/* If we're a nested call, same place. */
 	if ( ! nl)
-		return(in_line(m, tok, line, ppos, pos, buf));
+		return(in_line(mdoc, tok, line, ppos, pos, buf));
 
 	/*
 	 * XXX: this will open a block scope; however, if later we end
@@ -1686,9 +1746,9 @@
 	 * the formatting.  Be careful.
 	 */
 	if (MDOC_Nm == tok)
-		return(blk_full(m, tok, line, ppos, pos, buf));
+		return(blk_full(mdoc, tok, line, ppos, pos, buf));
 	assert(MDOC_Vt == tok);
-	return(blk_part_imp(m, tok, line, ppos, pos, buf));
+	return(blk_part_imp(mdoc, tok, line, ppos, pos, buf));
 }
 
 
@@ -1697,7 +1757,7 @@
 obsolete(MACRO_PROT_ARGS)
 {
 
-	mdoc_pmsg(m, line, ppos, MANDOCERR_MACROOBS);
+	mdoc_pmsg(mdoc, line, ppos, MANDOCERR_MACROOBS);
 	return(1);
 }
 
@@ -1708,7 +1768,7 @@
  * macro is encountered.
  */
 static int
-phrase(struct mdoc *m, int line, int ppos, char *buf)
+phrase(struct mdoc *mdoc, int line, int ppos, char *buf)
 {
 	int		 la, pos;
 	enum margserr	 ac;
@@ -1718,7 +1778,7 @@
 	for (pos = ppos; ; ) {
 		la = pos;
 
-		ac = mdoc_zargs(m, line, &pos, buf, &p);
+		ac = mdoc_zargs(mdoc, line, &pos, buf, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1728,14 +1788,14 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup_raw(p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX, 1))
 				return(0);
 			continue;
 		}
 
-		if ( ! mdoc_macro(m, ntok, line, la, &pos, buf))
+		if ( ! mdoc_macro(mdoc, ntok, line, la, &pos, buf))
 			return(0);
-		return(append_delims(m, line, &pos, buf));
+		return(append_delims(mdoc, line, &pos, buf));
 	}
 
 	return(1);
@@ -1746,24 +1806,30 @@
 static int
 phrase_ta(MACRO_PROT_ARGS)
 {
+	struct mdoc_node *n;
 	int		  la;
 	enum mdoct	  ntok;
 	enum margserr	  ac;
 	char		 *p;
 
-	/*
-	 * FIXME: this is overly restrictive: if the `Ta' is unexpected,
-	 * it should simply error out with ARGSLOST.
-	 */
+	/* Make sure we are in a column list or ignore this macro. */
+	n = mdoc->last;
+	while (NULL != n && MDOC_Bl != n->tok)
+		n = n->parent;
+	if (NULL == n || LIST_column != n->norm->Bl.type) {
+		mdoc_pmsg(mdoc, line, ppos, MANDOCERR_STRAYTA);
+		return(1);
+	}
 
-	if ( ! rew_sub(MDOC_BODY, m, MDOC_It, line, ppos))
+	/* Advance to the next column. */
+	if ( ! rew_sub(MDOC_BODY, mdoc, MDOC_It, line, ppos))
 		return(0);
-	if ( ! mdoc_body_alloc(m, line, ppos, MDOC_It))
+	if ( ! mdoc_body_alloc(mdoc, line, ppos, MDOC_It))
 		return(0);
 
 	for (;;) {
 		la = *pos;
-		ac = mdoc_zargs(m, line, pos, buf, &p);
+		ac = mdoc_zargs(mdoc, line, pos, buf, &p);
 
 		if (ARGS_ERROR == ac)
 			return(0);
@@ -1773,14 +1839,15 @@
 		ntok = ARGS_QWORD == ac ? MDOC_MAX : lookup_raw(p);
 
 		if (MDOC_MAX == ntok) {
-			if ( ! dword(m, line, la, p, DELIM_MAX))
+			if ( ! dword(mdoc, line, la, p, DELIM_MAX,
+			    MDOC_JOIN & mdoc_macros[tok].flags))
 				return(0);
 			continue;
 		}
 
-		if ( ! mdoc_macro(m, ntok, line, la, pos, buf))
+		if ( ! mdoc_macro(mdoc, ntok, line, la, pos, buf))
 			return(0);
-		return(append_delims(m, line, pos, buf));
+		return(append_delims(mdoc, line, pos, buf));
 	}
 
 	return(1);
